<?php

function slidingmarketing_get_option($key) {
	$options = get_option('slidingmarketing');
	
	return isset($options[$key]) ? $options[$key] : '';
	
}


function slidingmarketing_options_value($data, $param, $default_value = '') {
	if (is_object ( $data ) && isset ( $data->$param ))
		return $data->$param;
	else if (is_array ( $data ) && isset ( $data [$param] ))
		return $data [$param];
	else
		return $default_value;
}

function slidingmarketing_message_setting($message, $param) {
	return get_post_meta($message->ID, 'sm-'.$param, true);
}

function slidingmarketing_message_settings($message, $param) {
	return get_post_meta($message->ID, 'sm-'.$param);
}

function slidingmarketing_message_setting_draw($message, $param, $default = '') {
	$value = get_post_meta($message->ID, 'sm-'.$param, true);

	if ($value == '') {
		$value = $default;
	}

	echo esc_attr($value);
}


function slidingmarketing_get_taxonomy_hierarchy( $taxonomy, $parent = 0 ) {
	$taxonomy = is_array( $taxonomy ) ? array_shift( $taxonomy ) : $taxonomy;
	$terms = get_terms( $taxonomy, array( 'parent' => $parent, 'hide_empty' => false ) );
	$children = array();
	foreach ( $terms as $term ){
		$term->children = slidingmarketing_get_taxonomy_hierarchy( $taxonomy, $term->term_id );
		$children[ $term->term_id ] = $term;
	}
	return $children;
}

function slidingmarketing_convert_taxonomy_to_simplelist($taxonomies, $r = array(), $prefix = '') {
	
	foreach ($taxonomies as $term_id => $data) {
		$r[$term_id] = $prefix.$data->name;

		if ($data->children) {
			$r = slidingmarketing_convert_taxonomy_to_simplelist($data->children, $r, $prefix.$data->name . ' - ');
		}
	}
	
	return $r;
}
