<?php
function slidingmessages_side_fields( $meta_boxes ) {
	global $wp_post_types;
	
	$prefix = 'sm-';
	
	$pts = get_post_types ( array ('show_ui' => true, '_builtin' => true, 'public' => true ) );
	$cpts = get_post_types ( array ('show_ui' => true, '_builtin' => false, 'public' => true ) );
	
	$pt_list = array();
	
	foreach ( $pts as $pt ) {
		$pt_list[$pt] =  $wp_post_types [$pt]->label;
	}
	
	foreach ( $cpts as $pt ) {
		$pt_list[$pt] =  $wp_post_types [$pt]->label;
	}

	$pt_list['home'] = esc_html__('Homepage', 'slidingmarketing');
	
	$pt_list = apply_filters('slidingmarketing_attach_display_rules', $pt_list);
	
	$categories = slidingmarketing_convert_taxonomy_to_simplelist(slidingmarketing_get_taxonomy_hierarchy('category'));
//	print_r($categories);
	
	$meta_boxes[] = array(
			'id' => 'sm-sidepanel',
			'title' => esc_html__( 'Message Appearance', 'slidingmarketing' ),
			'post_types' => array( SLIDINGMESSAGES_POSTTYPE ),
			'context' => 'side',
			'priority' => 'core',
			'autosave' => false,
			'fields' => array(
					array(
							'id' => $prefix . 'manual-assign',
							'name' => esc_html__( 'Manual Appearance', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'Set this option if you wish to assign manually message from appearing on specific posts/pages only', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'always-displayed',
							'name' => esc_html__( 'Always Displayed', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'Set this option if you wish to your message always to appear on screen no matter of the random display settings', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'paused',
							'name' => esc_html__( 'Pause Message', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'Set this option if you wish to temporary pause message from appearing', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'nocookies',
							'name' => esc_html__( 'Don\'t Apply On Close Rules', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'Set this option if you wish the message be always visible on screen no matter of close user rules. This option will avoid the cookie check for shown message.', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'post-types',
							'name' => esc_html__( 'Appear Only On Post Types', 'slidingmarketing' ),
							'type' => 'select_advanced',
							'desc' => esc_html__( 'Limit message from appearing on specific post types or homepage only', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => $pt_list,
							'multiple' => true,
							'select_all_none' => true,
					),			
					array(
							'id' => $prefix . 'categories',
							'name' => esc_html__( 'Appear Only On Selected Categories', 'slidingmarketing' ),
							'type' => 'select_advanced',
							'desc' => esc_html__( 'Limit message from appearing on categories only', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => $categories,
							'multiple' => true,
							'select_all_none' => true,
					),
					array(
							'id' => $prefix . 'archive-pages',
							'name' => esc_html__( 'Appear Only On Selected Above Categorie Pages', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'If you set a list selected categories where you wish message to appear with this option you will make message appear just on taxonomy page (category archive). Without this option active message will appear on all posts from selected categories.', 'slidingmarketing' ),
					),					
					array(
							'id' => $prefix . 'fromdate',
							'type' => 'date',
							'name' => esc_html__( 'From Date', 'slidingmarketing' ),
							'desc' => esc_html__( 'Set interval when message will be active only', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'todate',
							'type' => 'date',
							'name' => esc_html__( 'To Date', 'slidingmarketing' ),
							'desc' => esc_html__( 'End date of interval for automated message appearance', 'slidingmarketing' ),
					),
					

			),
	);

	return $meta_boxes;
}
add_filter( 'rwmb_meta_boxes', 'slidingmessages_side_fields' );


function slidingmessages_message_type( $meta_boxes ) {
	$prefix = 'sm-';

	$meta_boxes[] = array(
			'id' => 'sm-message-type',
			'title' => esc_html__( 'Message Type', 'slidingmarketing' ),
			'post_types' => SLIDINGMESSAGES_POSTTYPE,
			'context' => 'advanced',
			'priority' => 'high',
			'autosave' => false,
			'fields' => array(
					array ('type' => 'custom_html', 'std' => '<div><b>Available content shortcodes</b></div>
							<div>[sm-close text="Custom close message text" classes="" button="no|light|dark"] - add in content custom close text link or close button</div>
							<div>[sm-countdown date="2017/11/23 23:00" mode="light|dark" shadow="yes|no" mini="yes|no"] - add countdown timer</div>
							<div>[sm-button size="small|medium|large" style="regular|rounded" title="" url="" target="" bg_color="" txt_color="" nofollow="0|1" close="no|yes"] - add custom button</div>
							<div>[sm-highlight bg_color="" text_color=""]text to highlight[/sm-highlight] - highlight text</div>
							<div>[sm-col][/sm-col] - add row</div>
							<div>[sm-one-half][/sm-one-half] - add 1/2 column</div>
							<div>[sm-one-third][/sm-one-third] - add 1/3 column</div>
							<div>[sm-one-quarter][/sm-one-quarter] - add 1/4 column</div>
							<div>[sm-two-thirds][/sm-two-thirds] - add 2/3 column</div>
							<div>[sm-subscribe form_mode="default|inline"] - add subscribe form at manual location in your message</div>
							<div>[sm-post post_id="" prev_post="yes|no" next_post="yes|no" thumb_size="" design="full|mini"] - add post card information</div>
							'),
					array(
							'id' => $prefix . 'message-type',
							'name' => esc_html__( 'Message Displayed Content', 'slidingmarketing' ),
							'desc' => esc_html__( 'Choose compontents that will be displayed inside your message. You can select one or more than one at same time.', 'slidingmarketing' ),
							'type' => 'checkbox_list',
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									'text' => 'Free text/html/shortcodes message',
									'sidebar' => 'Sidebar',
									'related' => 'Related Posts',
									'optin' => 'Subscribe Form',
							),
							'std' => 'text',
					),
					array(
							'id' => 'sm-heading-sidebar',
							'type' => 'heading',
							'name' => esc_html__( 'Sidebar Display Setup', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'sidebar-id',
							'name' => esc_html__( 'Sidebar', 'slidingmarketing' ),
							'type' => 'select',
							'desc' => esc_html__( 'Choose which sidebar you wish to display when message is set to sidebar appearance', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									1 => '1',
									'2',
									'3',
									'4',
									'5',
									'6',
									'7',
									'8',
									'9',
									'10',
							),
							'std' => '1',
					),
					array(
							'id' => 'sm-heading-related',
							'type' => 'heading',
							'name' => esc_html__( 'Related Posts Setup', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'related-count',
							'name' => esc_html__( 'Posts Count', 'slidingmarketing' ),
							'type' => 'select',
							'desc' => esc_html__( 'Choose how many posts you wish to see in the related posts display', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									1 => '1',
									'2',
									'3',
									'4',
									'5',
									'67',
									'7',
									'8',
									'9',
									'10',
							),
							'std' => '1',
					),
					array(
							'id' => $prefix . 'relation-type',
							'name' => esc_html__( 'Relation Type', 'slidingmarketing' ),
							'type' => 'select',
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									'category' => 'Category',
									'tag' => 'Tag',
							),
					),
					array(
							'id' => $prefix . 'related-design',
							'name' => esc_html__( 'Display', 'slidingmarketing' ),
							'type' => 'select',
							'desc' => esc_html__( 'Choose display style of the related posts', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									'classic' => 'Classic (Image on the left, title and meta details)',
									'minimal' => 'Minimal (Title & meta details)',
									'jumbo' => 'Jumbo (Big image, title & meta details)',
							),
							'std' => 'classic',
					),
					
					array(
							'id' => 'sm-heading-subscribe',
							'type' => 'heading',
							'name' => esc_html__( 'Subscribe Form Texts & Style', 'slidingmarketing' ),
					),
					
					array(
							'id' => $prefix . 'subscribe-mail-placeholder',
							'type' => 'text',
							'name' => esc_html__( 'Email Placeholder Text', 'slidingmessage' ),
							'desc' => esc_html__( 'Set own custom text to overwrite Enter your email', 'slidingmessage' ),
					),
					array(
							'id' => $prefix . 'subscribe-mail-button',
							'type' => 'text',
							'name' => esc_html__( 'Subscribe Button Text', 'slidingmessage' ),
							'desc' => esc_html__( 'Change text that will appear over subscribe button', 'slidingmessage' ),
					),
					array(
							'id' => $prefix . 'subscribe-button-textcolor',
							'name' => esc_html__( 'Customize Button Background Color', 'slidingmarketing' ),
							'type' => 'color',
					),
					array(
							'id' => $prefix . 'subscribe-button-bgcolor',
							'name' => esc_html__( 'Customize Button Text Color', 'slidingmarketing' ),
							'type' => 'color',
					),
			),
	);

	return $meta_boxes;
}
add_filter( 'rwmb_meta_boxes', 'slidingmessages_message_type' );

function slidingmessages_message_appearance( $meta_boxes ) {
	$prefix = 'sm-';

	$meta_boxes[] = array(
			'id' => 'sm-message-appearance',
			'title' => esc_html__( 'Message Appearance', 'slidingmessage' ),
			'post_types' => SLIDINGMESSAGES_POSTTYPE,
			'context' => 'advanced',
			'priority' => 'high',
			'autosave' => false,
			'fields' => array(
					array(
							'id' => $prefix . 'show-at',
							'name' => esc_html__( 'Show Message When', 'slidingmessage' ),
							'type' => 'select',
							'desc' => esc_html__( 'Choose when message will automatically appear on screen', 'slidingmessage' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmessage' ),
							'options' => array(
									'time' => 'Time Delayed',
									'scroll' => 'On Scroll',
									'element' => 'When Element is Passed',
							),
							'std' => 'time',
					),
					array(
							'id' => $prefix . 'show-at-condition',
							'type' => 'text',
							'name' => esc_html__( 'Display Condition Value', 'slidingmessage' ),
							'desc' => esc_html__( 'Set a proper value based on the event you select for message appearance (example: Time -> 30 (30 seconds), Scroll -> 20 (20%), Element -> #comments (When element with ID comments is on screen)', 'slidingmessage' ),
					),
					array(
							'id' => $prefix . 'disappear-after',
							'type' => 'text',
							'name' => esc_html__( 'Automatically Disappear After', 'slidingmessage' ),
							'desc' => esc_html__( 'Set a numeric value of seconds here if you wish to make your message disappear', 'slidingmessage' ),
							'placeholder' => esc_html__( 'Only numeric value (example 30) or leave blank to keep message on screen)', 'slidingmessage' ),
					),
					array(
							'id' => $prefix . 'disappear-hide',
							'name' => esc_html__( 'Do Not Show This Message Again', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'Set this option if you wish the message to disappear upon close by the user and do not show again, no matter what you have set inside options for closing a message. Fill the number of days below or leave blank for the default value of 1 month.', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'disappear-hide-days',
							'type' => 'text',
							'name' => esc_html__( 'Do Not Show for Number of Days', 'slidingmessage' ),
							'placeholder' => esc_html__( 'Only numeric value (example 30)', 'slidingmessage' ),
					),
					
			),
	);

	return $meta_boxes;
}
add_filter( 'rwmb_meta_boxes', 'slidingmessages_message_appearance' );

function slidingmessages_message_position_style( $meta_boxes ) {
	$prefix = 'sm-';

	$meta_boxes[] = array(
		'id' => 'sm-position-style',
		'title' => esc_html__( 'Message Position & Style', 'slidingmarketing' ),
		'post_types' => SLIDINGMESSAGES_POSTTYPE,
		'context' => 'advanced',
		'priority' => 'high',
		'autosave' => false,
		'fields' => array(
			array(
				'id' => $prefix . 'position',
				'name' => esc_html__( 'Position On Screen', 'slidingmarketing' ),
				'type' => 'select',
				'desc' => esc_html__( 'Choose where message will be placed on screen', 'slidingmarketing' ),
				'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
				'options' => array(
					'bottom-right' => 'Bottom Right',
					'bottom-left' => 'Bottom Left',
					'top-right' => 'Top Right',
					'top-left' => 'Top Left',
					'right' => 'Center Right',
					'left' => 'Center Left',
					'center' => 'Center On Screen',
					'topbar' => 'Top Bar',
					'bottombar' => 'Bottom Bar',
					'left-sidebar' => 'Left Sidebar',
					'right-sidebar' => 'Right Sidebar',
					'full' => 'Full Screen',
				),
				'std' => 'bottom-right',
			),
				
				array(
						'id' => $prefix . 'shadow',
						'name' => esc_html__( 'Highlight Message', 'slidingmarketing' ),
						'type' => 'select',
						'desc' => esc_html__( 'Add effect to highlight message on screen', 'slidingmarketing' ),
						'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
						'options' => array(
								'noshadow' => 'Without Effect',
								'glow' => 'Glow Shadow',
								'border' => 'Border',
						),
						'std' => 'glow',
				),
				
			array(
				'id' => $prefix . 'width',
				'type' => 'text',
				'name' => esc_html__( 'Custom Message Width', 'slidingmarketing' ),
				'desc' => esc_html__( 'Only when message is displayed in non full width display (full width displays include: Bottom Bar, Top Bar, Full Screen)', 'slidingmarketing' ),
				'placeholder' => esc_html__( 'Numeric values only (example: 640)', 'slidingmarketing' ),
			),
			array(
				'id' => $prefix . 'height',
				'type' => 'text',
				'name' => esc_html__( 'Custom Message Height', 'slidingmarketing' ),
				'desc' => esc_html__( 'Set custom message height when non full height display is selected (full height displays: Left or Right Sidebar, Full Screen Message)', 'slidingmarketing' ),
				'placeholder' => esc_html__( 'Numeric values (example: 100)', 'slidingmarketing' ),
			),
				array(
						'id' => $prefix . 'center-vertical',
						'name' => esc_html__( 'Center Content Vertically', 'slidingmarketing' ),
						'type' => 'checkbox',
						'desc' => esc_html__( 'Set this option if you wish to center your content vertically (usally when sidebar is used)', 'slidingmarketing' ),
				),
				
			array(
				'id' => $prefix . 'background',
				'name' => esc_html__( 'Background Color', 'slidingmarketing' ),
				'type' => 'color',
				'alpha_channel' => true,
				'desc' => esc_html__( 'Set own message background color', 'slidingmarketing' ),
			),
			array(
				'id' => $prefix . 'remove-background',
				'name' => esc_html__( 'Without Background Color', 'slidingmarketing' ),
				'type' => 'checkbox',
				'desc' => esc_html__( 'Set this option if you wish to remove message background color', 'slidingmarketing' ),
			),
			array(
				'id' => $prefix . 'textcolor',
				'name' => esc_html__( 'Text Color', 'slidingmarketing' ),
				'type' => 'color',
				'desc' => esc_html__( 'Custom text color', 'slidingmarketing' ),
			),
			array(
				'id' => $prefix . 'highlight',
				'name' => esc_html__( 'Highlight Color', 'slidingmarketing' ),
				'type' => 'color',
				'desc' => esc_html__( 'Set custom highlight color', 'slidingmarketing' ),
			),
			array(
				'id' => $prefix . 'padding',
				'type' => 'text',
				'name' => esc_html__( 'Padding', 'slidingmarketing' ),
				'desc' => 'The padding property can have from one to four values: 20px (all four paddings are 20px), 10px 20px (top and bottom are 10px, left and right 20px), 10px 20px 30px 40px (top is 10px, right is 20px, bottom is 30px, left is 40px)',
			),
			array(
				'id' => $prefix . 'background-image',
				'type' => 'image_advanced',
				'name' => esc_html__( 'Background Image', 'slidingmarketing' ),
				'desc' => esc_html__( 'Optional choose a message background image', 'slidingmarketing' ),
				'max_file_uploads' => '1',
				'max_status' => false,
			),
				
				array(
						'id' => $prefix . 'effect',
						'name' => esc_html__( 'Entrance Effect', 'slidingmarketing' ),
						'type' => 'select',
						'desc' => esc_html__( 'Use this selection to add entrance animation for more attention grabbing effect over audience', 'slidingmarketing' ),
						'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
						'options' => array(
								'no' => 'Without Effect',
								'effect1' => 'Effect #1',
								'effect2' => 'Effect #2',
								'effect3' => 'Effect #3',
								'effect4' => 'Effect #4',
								'effect5' => 'Effect #5',
						),
						'std' => 'no',
				),
		),
	);

	return $meta_boxes;
}
add_filter( 'rwmb_meta_boxes', 'slidingmessages_message_position_style' );

function slidingmessages_generate_close( $meta_boxes ) {
	$prefix = 'sm-';
	
	$falist = array("fa-500px","fa-address-book","fa-address-book-o","fa-address-card","fa-address-card-o","fa-adjust","fa-adn","fa-align-center","fa-align-justify","fa-align-left","fa-align-right","fa-amazon","fa-ambulance","fa-american-sign-language-interpreting","fa-anchor","fa-android","fa-angellist","fa-angle-double-down","fa-angle-double-left","fa-angle-double-right","fa-angle-double-up","fa-angle-down","fa-angle-left","fa-angle-right","fa-angle-up","fa-apple","fa-archive","fa-area-chart","fa-arrow-circle-down","fa-arrow-circle-left","fa-arrow-circle-o-down","fa-arrow-circle-o-left","fa-arrow-circle-o-right","fa-arrow-circle-o-up","fa-arrow-circle-right","fa-arrow-circle-up","fa-arrow-down","fa-arrow-left","fa-arrow-right","fa-arrow-up","fa-arrows","fa-arrows-alt","fa-arrows-h","fa-arrows-v","fa-assistive-listening-systems","fa-asterisk","fa-at","fa-audio-description","fa-backward","fa-balance-scale","fa-ban","fa-bandcamp","fa-bar-chart","fa-barcode","fa-bars","fa-bath","fa-battery-empty","fa-battery-full","fa-battery-half","fa-battery-quarter","fa-battery-three-quarters","fa-bed","fa-beer","fa-behance","fa-behance-square","fa-bell","fa-bell-o","fa-bell-slash","fa-bell-slash-o","fa-bicycle","fa-binoculars","fa-birthday-cake","fa-bitbucket","fa-bitbucket-square","fa-black-tie","fa-blind","fa-bluetooth","fa-bluetooth-b","fa-bold","fa-bolt","fa-bomb","fa-book","fa-bookmark","fa-bookmark-o","fa-braille","fa-briefcase","fa-btc","fa-bug","fa-building","fa-building-o","fa-bullhorn","fa-bullseye","fa-bus","fa-buysellads","fa-calculator","fa-calendar","fa-calendar-check-o","fa-calendar-minus-o","fa-calendar-o","fa-calendar-plus-o","fa-calendar-times-o","fa-camera","fa-camera-retro","fa-car","fa-caret-down","fa-caret-left","fa-caret-right","fa-caret-square-o-down","fa-caret-square-o-left","fa-caret-square-o-right","fa-caret-square-o-up","fa-caret-up","fa-cart-arrow-down","fa-cart-plus","fa-cc","fa-cc-amex","fa-cc-diners-club","fa-cc-discover","fa-cc-jcb","fa-cc-mastercard","fa-cc-paypal","fa-cc-stripe","fa-cc-visa","fa-certificate","fa-chain-broken","fa-check","fa-check-circle","fa-check-circle-o","fa-check-square","fa-check-square-o","fa-chevron-circle-down","fa-chevron-circle-left","fa-chevron-circle-right","fa-chevron-circle-up","fa-chevron-down","fa-chevron-left","fa-chevron-right","fa-chevron-up","fa-child","fa-chrome","fa-circle","fa-circle-o","fa-circle-o-notch","fa-circle-thin","fa-clipboard","fa-clock-o","fa-clone","fa-cloud","fa-cloud-download","fa-cloud-upload","fa-code","fa-code-fork","fa-codepen","fa-codiepie","fa-coffee","fa-cog","fa-cogs","fa-columns","fa-comment","fa-comment-o","fa-commenting","fa-commenting-o","fa-comments","fa-comments-o","fa-compass","fa-compress","fa-connectdevelop","fa-contao","fa-copyright","fa-creative-commons","fa-credit-card","fa-credit-card-alt","fa-crop","fa-crosshairs","fa-css3","fa-cube","fa-cubes","fa-cutlery","fa-dashcube","fa-database","fa-deaf","fa-delicious","fa-desktop","fa-deviantart","fa-diamond","fa-digg","fa-dot-circle-o","fa-download","fa-dribbble","fa-dropbox","fa-drupal","fa-edge","fa-eercast","fa-eject","fa-ellipsis-h","fa-ellipsis-v","fa-empire","fa-envelope","fa-envelope-o","fa-envelope-open","fa-envelope-open-o","fa-envelope-square","fa-envira","fa-eraser","fa-etsy","fa-eur","fa-exchange","fa-exclamation","fa-exclamation-circle","fa-exclamation-triangle","fa-expand","fa-expeditedssl","fa-external-link","fa-external-link-square","fa-eye","fa-eye-slash","fa-eyedropper","fa-facebook","fa-facebook-official","fa-facebook-square","fa-fast-backward","fa-fast-forward","fa-fax","fa-female","fa-fighter-jet","fa-file","fa-file-archive-o","fa-file-audio-o","fa-file-code-o","fa-file-excel-o","fa-file-image-o","fa-file-o","fa-file-pdf-o","fa-file-powerpoint-o","fa-file-text","fa-file-text-o","fa-file-video-o","fa-file-word-o","fa-files-o","fa-film","fa-filter","fa-fire","fa-fire-extinguisher","fa-firefox","fa-first-order","fa-flag","fa-flag-checkered","fa-flag-o","fa-flask","fa-flickr","fa-floppy-o","fa-folder","fa-folder-o","fa-folder-open","fa-folder-open-o","fa-font","fa-font-awesome","fa-fonticons","fa-fort-awesome","fa-forumbee","fa-forward","fa-foursquare","fa-free-code-camp","fa-frown-o","fa-futbol-o","fa-gamepad","fa-gavel","fa-gbp","fa-genderless","fa-get-pocket","fa-gg","fa-gg-circle","fa-gift","fa-git","fa-git-square","fa-github","fa-github-alt","fa-github-square","fa-gitlab","fa-glass","fa-glide","fa-glide-g","fa-globe","fa-google","fa-google-plus","fa-google-plus-official","fa-google-plus-square","fa-google-wallet","fa-graduation-cap","fa-gratipay","fa-grav","fa-h-square","fa-hacker-news","fa-hand-lizard-o","fa-hand-o-down","fa-hand-o-left","fa-hand-o-right","fa-hand-o-up","fa-hand-paper-o","fa-hand-peace-o","fa-hand-pointer-o","fa-hand-rock-o","fa-hand-scissors-o","fa-hand-spock-o","fa-handshake-o","fa-hashtag","fa-hdd-o","fa-header","fa-headphones","fa-heart","fa-heart-o","fa-heartbeat","fa-history","fa-home","fa-hospital-o","fa-hourglass","fa-hourglass-end","fa-hourglass-half","fa-hourglass-o","fa-hourglass-start","fa-houzz","fa-html5","fa-i-cursor","fa-id-badge","fa-id-card","fa-id-card-o","fa-ils","fa-imdb","fa-inbox","fa-indent","fa-industry","fa-info","fa-info-circle","fa-inr","fa-instagram","fa-internet-explorer","fa-ioxhost","fa-italic","fa-joomla","fa-jpy","fa-jsfiddle","fa-key","fa-keyboard-o","fa-krw","fa-language","fa-laptop","fa-lastfm","fa-lastfm-square","fa-leaf","fa-leanpub","fa-lemon-o","fa-level-down","fa-level-up","fa-life-ring","fa-lightbulb-o","fa-line-chart","fa-link","fa-linkedin","fa-linkedin-square","fa-linode","fa-linux","fa-list","fa-list-alt","fa-list-ol","fa-list-ul","fa-location-arrow","fa-lock","fa-long-arrow-down","fa-long-arrow-left","fa-long-arrow-right","fa-long-arrow-up","fa-low-vision","fa-magic","fa-magnet","fa-male","fa-map","fa-map-marker","fa-map-o","fa-map-pin","fa-map-signs","fa-mars","fa-mars-double","fa-mars-stroke","fa-mars-stroke-h","fa-mars-stroke-v","fa-maxcdn","fa-meanpath","fa-medium","fa-medkit","fa-meetup","fa-meh-o","fa-mercury","fa-microchip","fa-microphone","fa-microphone-slash","fa-minus","fa-minus-circle","fa-minus-square","fa-minus-square-o","fa-mixcloud","fa-mobile","fa-modx","fa-money","fa-moon-o","fa-motorcycle","fa-mouse-pointer","fa-music","fa-neuter","fa-newspaper-o","fa-object-group","fa-object-ungroup","fa-odnoklassniki","fa-odnoklassniki-square","fa-opencart","fa-openid","fa-opera","fa-optin-monster","fa-outdent","fa-pagelines","fa-paint-brush","fa-paper-plane","fa-paper-plane-o","fa-paperclip","fa-paragraph","fa-pause","fa-pause-circle","fa-pause-circle-o","fa-paw","fa-paypal","fa-pencil","fa-pencil-square","fa-pencil-square-o","fa-percent","fa-phone","fa-phone-square","fa-picture-o","fa-pie-chart","fa-pied-piper","fa-pied-piper-alt","fa-pied-piper-pp","fa-pinterest","fa-pinterest-p","fa-pinterest-square","fa-plane","fa-play","fa-play-circle","fa-play-circle-o","fa-plug","fa-plus","fa-plus-circle","fa-plus-square","fa-plus-square-o","fa-podcast","fa-power-off","fa-print","fa-product-hunt","fa-puzzle-piece","fa-qq","fa-qrcode","fa-question","fa-question-circle","fa-question-circle-o","fa-quora","fa-quote-left","fa-quote-right","fa-random","fa-ravelry","fa-rebel","fa-recycle","fa-reddit","fa-reddit-alien","fa-reddit-square","fa-refresh","fa-registered","fa-renren","fa-repeat","fa-reply","fa-reply-all","fa-retweet","fa-road","fa-rocket","fa-rss","fa-rss-square","fa-rub","fa-safari","fa-scissors","fa-scribd","fa-search","fa-search-minus","fa-search-plus","fa-sellsy","fa-server","fa-share","fa-share-alt","fa-share-alt-square","fa-share-square","fa-share-square-o","fa-shield","fa-ship","fa-shirtsinbulk","fa-shopping-bag","fa-shopping-basket","fa-shopping-cart","fa-shower","fa-sign-in","fa-sign-language","fa-sign-out","fa-signal","fa-simplybuilt","fa-sitemap","fa-skyatlas","fa-skype","fa-slack","fa-sliders","fa-slideshare","fa-smile-o","fa-snapchat","fa-snapchat-ghost","fa-snapchat-square","fa-snowflake-o","fa-sort","fa-sort-alpha-asc","fa-sort-alpha-desc","fa-sort-amount-asc","fa-sort-amount-desc","fa-sort-asc","fa-sort-desc","fa-sort-numeric-asc","fa-sort-numeric-desc","fa-soundcloud","fa-space-shuttle","fa-spinner","fa-spoon","fa-spotify","fa-square","fa-square-o","fa-stack-exchange","fa-stack-overflow","fa-star","fa-star-half","fa-star-half-o","fa-star-o","fa-steam","fa-steam-square","fa-step-backward","fa-step-forward","fa-stethoscope","fa-sticky-note","fa-sticky-note-o","fa-stop","fa-stop-circle","fa-stop-circle-o","fa-street-view","fa-strikethrough","fa-stumbleupon","fa-stumbleupon-circle","fa-subscript","fa-subway","fa-suitcase","fa-sun-o","fa-superpowers","fa-superscript","fa-table","fa-tablet","fa-tachometer","fa-tag","fa-tags","fa-tasks","fa-taxi","fa-telegram","fa-television","fa-tencent-weibo","fa-terminal","fa-text-height","fa-text-width","fa-th","fa-th-large","fa-th-list","fa-themeisle","fa-thermometer-empty","fa-thermometer-full","fa-thermometer-half","fa-thermometer-quarter","fa-thermometer-three-quarters","fa-thumb-tack","fa-thumbs-down","fa-thumbs-o-down","fa-thumbs-o-up","fa-thumbs-up","fa-ticket","fa-times","fa-times-circle","fa-times-circle-o","fa-tint","fa-toggle-off","fa-toggle-on","fa-trademark","fa-train","fa-transgender","fa-transgender-alt","fa-trash","fa-trash-o","fa-tree","fa-trello","fa-tripadvisor","fa-trophy","fa-truck","fa-try","fa-tty","fa-tumblr","fa-tumblr-square","fa-twitch","fa-twitter","fa-twitter-square","fa-umbrella","fa-underline","fa-undo","fa-universal-access","fa-university","fa-unlock","fa-unlock-alt","fa-upload","fa-usb","fa-usd","fa-user","fa-user-circle","fa-user-circle-o","fa-user-md","fa-user-o","fa-user-plus","fa-user-secret","fa-user-times","fa-users","fa-venus","fa-venus-double","fa-venus-mars","fa-viacoin","fa-viadeo","fa-viadeo-square","fa-video-camera","fa-vimeo","fa-vimeo-square","fa-vine","fa-vk","fa-volume-control-phone","fa-volume-down","fa-volume-off","fa-volume-up","fa-weibo","fa-weixin","fa-whatsapp","fa-wheelchair","fa-wheelchair-alt","fa-wifi","fa-wikipedia-w","fa-window-close","fa-window-close-o","fa-window-maximize","fa-window-minimize","fa-window-restore","fa-windows","fa-wordpress","fa-wpbeginner","fa-wpexplorer","fa-wpforms","fa-wrench","fa-xing","fa-xing-square","fa-y-combinator","fa-yahoo","fa-yelp","fa-yoast","fa-youtube","fa-youtube-play","fa-youtube-square");
	
	$fapicker = array();
	$fapicker[""] = "Without Icon";
	
	foreach ($falist as $icon) {
		$fapicker[$icon] = $icon;
	}
	

	$meta_boxes[] = array(
			'id' => 'sm-close-button',
			'title' => esc_html__( 'Message Close', 'slidingmarketing' ),
			'post_types' => SLIDINGMESSAGES_POSTTYPE,
			'context' => 'advanced',
			'priority' => 'high',
			'autosave' => false,
			'fields' => array(
					array(
							'id' => $prefix . 'close-hide',
							'name' => esc_html__( 'Without Close Button', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'If you need to hide close button on message check this option', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'close-size',
							'name' => esc_html__( 'Close Button Size', 'slidingmarketing' ),
							'type' => 'select',
							'desc' => esc_html__( 'Customize size of close button', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									'small' => 'Small',
									'medium' => 'Medium',
									'large' => 'Large',
							),
							'std' => 'small',
					),
					array(
							'id' => $prefix . 'close-shape',
							'name' => esc_html__( 'Close Button Shape', 'slidingmarketing' ),
							'type' => 'select',
							'desc' => esc_html__( 'Customize shape of the close button', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									'circle' => 'Circle',
									'square' => 'Square',
									'icon' => 'Icon Only',
							),
							'std' => 'circle',
					),
					array(
							'id' => $prefix . 'close-color',
							'name' => esc_html__( 'Close Button Color', 'slidingmarketing' ),
							'type' => 'color',
							'desc' => esc_html__( 'Customize default color of close icon', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'close-background',
							'name' => esc_html__( 'Close Button Background Color', 'slidingmarketing' ),
							'type' => 'color',
							'desc' => esc_html__( 'Customize default close button background color (not used if you choose just icon placement)', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'close-placement',
							'name' => esc_html__( 'Close Button Appearance', 'slidingmarketing' ),
							'type' => 'select',
							'desc' => esc_html__( 'Choose where button will appear', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									'inside' => 'Inside Message',
									'outside' => 'Outside Message',
							),
							'std' => 'inside',
					),
					array ('type' => 'custom_html', 'class' => 'sm-reopen-panel', 'callback' => 'slidingmessages_draw_reopen_panel_start'),
					array(
							'id' => 'reopen-button',
							'type' => 'heading',
							'desc' => esc_html__( 'Re-open message button allows to show a button which will be visible when user close the message or if you set to be visible when message is not displayed on codition', 'slidingmarketing' ),
							'name' => esc_html__( 'Re-open Message Button', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'reopen-show',
							'name' => esc_html__( 'Display re-open button when user close the message', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'Set this option if you wish user to see a button to open message again.', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'open-show',
							'name' => esc_html__( 'Display open button when message is not displayed', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'Set this option if you wish to show a button for user to open message before display condition run', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'open-content',
							'type' => 'text',
							'name' => esc_html__( 'Open Button Text/Content', 'slidingmarketing' ),
							'desc' => esc_html__( 'Set button text/content to display - this can be html code or just plain text (icon font also can be used)', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'open-background',
							'name' => esc_html__( 'Background Color', 'slidingmarketing' ),
							'type' => 'color',
							'desc' => esc_html__( 'Set open button custom background color', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'open-textcolor',
							'name' => esc_html__( 'Text Color', 'slidingmarketing' ),
							'type' => 'color',
							'desc' => esc_html__( 'Set custom text color of the open button', 'slidingmarketing' ),
					),
					array(
							'name'            => esc_html__( 'Include FontAwesome icon in the button', 'slidingmarketing' ),
							'id'              => $prefix.'fa-icon',
							'type'            => 'select_advanced',
							'desc' => esc_html__( 'A list of all FontAwesome icons you can find here: http://fontawesome.io/icons/', 'slidingmarketing' ),
							// Array of 'value' => 'Label' pairs
							'options'         => $fapicker,
							// Allow to select multiple value?
							'multiple'        => false,
							// Placeholder text
							'placeholder'     => 'Select an Item',
							// Display "Select All / None" button?
							'select_all_none' => false,
							// select2 configuration. See https://select2.org/configuration
							
					),
					array(
							'id' => $prefix . 'fa-size',
							'name' => esc_html__( 'FontAwesome icon size', 'slidingmarketing' ),
							'type' => 'select',
							'desc' => esc_html__( 'Use this selection if you need to set a custom size of the icon.', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => array(
									'' => 'Default',
									'fa-lg' => 'Small',
									'fa-2x' => 'Medium',
									'fa-3x' => 'Large',
									'fa-4x' => 'Extra Large',
									'fa-5x' => 'Jumbo',
							),
							'std' => '',
					),
					array ('type' => 'custom_html', 'std' => '</div>'),
					
			),
	);

	return $meta_boxes;
}
add_filter( 'rwmb_meta_boxes', 'slidingmessages_generate_close' );


function slidingmessages_metabox_manual( $meta_boxes ) {
	
	// Reading all manual assigned messages
	$query = new WP_Query ( array ('post_type' => SLIDINGMESSAGES_POSTTYPE, 
			'posts_per_page' => '-1' ) );
	$messages = $query->posts;

	$message_source = array();
	
	foreach ( $messages as $message ) {
		$is_manual = get_post_meta($message->ID, 'sm-manual-assign', true);
		
		if ($is_manual) {
			$message_source[$message->ID] = $message->post_title;
		}
	}
	
	$pts = get_post_types ( array ('show_ui' => true, '_builtin' => true, 'public' => true ) );
	$cpts = get_post_types ( array ('show_ui' => true, '_builtin' => false, 'public' => true ) );
	
	$pt_list = array();
	
	foreach ( $pts as $pt ) {
		$pt_list[] =  $pt;
	}
	
	foreach ( $cpts as $pt ) {
		$pt_list[] = $pt;
	}
	
	$prefix = 'sm-';

	$meta_boxes[] = array(
			'id' => 'sm-manual-select',
			'title' => esc_html__( 'Sliding Marketing Message', 'slidingmarketing' ),
			'post_types' => $pt_list,
			'context' => 'side',
			'priority' => 'default',
			'autosave' => false,
			'fields' => array(
					array(
							'id' => $prefix . 'show-manual',
							'name' => esc_html__( 'Show Only Assigned Message', 'slidingmarketing' ),
							'type' => 'checkbox',
							'desc' => esc_html__( 'Set this option if you wish your page/post to show just assigned by you message', 'slidingmarketing' ),
					),
					array(
							'id' => $prefix . 'manual-messages',
							'name' => esc_html__( 'Select Message to Appear', 'slidingmarketing' ),
							'type' => 'select_advanced',
							'desc' => esc_html__( 'Choose one or more manual message which will appear on this post/page', 'slidingmarketing' ),
							'placeholder' => esc_html__( 'Select an Item', 'slidingmarketing' ),
							'options' => $message_source,
							'multiple' => true,
							'select_all_none' => true,
					),
			),
	);

	return $meta_boxes;
}
add_filter( 'rwmb_meta_boxes', 'slidingmessages_metabox_manual' );

function slidingmessages_draw_reopen_panel_start() {
	return '<div class="sm-reopen-panel">';
}