<div class="slidingmarketing-setup">
<?php

$updated_settings = isset($_REQUEST['settings-updated']) ? $_REQUEST['settings-updated'] : '';

function slidingmessages_create_radio ($name, $value, $value_as_class=false) {
	$opt = slidingmarketing_get_option($name);
	$checked = (@$opt == $value) ? true : false;
	$name = esc_attr($name);
	$class = $value_as_class ? "class='{$name} {$value}'" : '';
	return "<input type='radio' name='sm[{$name}]' {$class} id='{$name}-{$value}' value='{$value}' " . ($checked ? 'checked="checked" ' : '') . " /> ";
}


?>

<div class="wrap">

	<?php
	
	if ($updated_settings == "true") {
		echo '<div class="updated sm-message-updated">Settings are saved!</div>';
	}
	
	?>

	<form action="" method="post" class="smui-ui">
		<div class="sm-options">
			<div class="sm-options-header" id="sm-options-header">
				<div class="sm-options-title">
					<h2>
						<?php esc_html_e('WordPress Marketing Plugin - Sliding Messages', 'slidingmarketing'); ?></h2>
						<span class="label" ><a href="https://codecanyon.net/item/easy-slidein-for-wordpress/7742759" target="_blank">Version <?php echo SLIDINGMESSAGES_VERSION; ?></a></span>
					</h2>
				</div>
				<div class="sm-options-right">
					<button name="Submit" type="submit" class="button-primary"><?php esc_attr_e('Save Changes', 'slidingmarketing'); ?></button>
				</div>
			</div>
			<div class="sm-options-container">
				<?php settings_fields('slidingmarketing'); ?>
				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title"><?php esc_html_e('On Message Close', 'slidingmarketing'); ?></div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%" class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">After message close:<br /> <span
								class="sm-info-label">Set what will happen if user closes a message</span></td>
							<td>
						  <?php
								echo '<div class="sm-onhide-condition">' . slidingmessages_create_radio ( 'on_hide', '', true ) . '<label for="on_hide-">' . esc_html__( 'Do nothing - continue to show the message', 'slidingmarketing' ) . '</label>' . '</div>';
								echo '<div class="sm-onhide-condition">' . slidingmessages_create_radio ( 'on_hide', 'page', true ) . '<label for="on_hide-page">' . esc_html__( 'Do not show message again on that page', 'slidingmarketing' ) . '</label>' . '</div>';
								echo '<div class="sm-onhide-condition">' . slidingmessages_create_radio ( 'on_hide', 'all', true ) . '<label for="on_hide-all">' . esc_html__( 'Do not show messages on all pages', 'slidingmarketing' ) . '</label>' . '</div>';
								
								$_times = array_combine ( range ( 1, 31 ), range ( 1, 31 ) );
								$_units = array ('hours' => esc_html__( 'Hours', 'slidingmarketing' ), 'days' => esc_html__( 'Days', 'slidingmarketing' ), 'weeks' => esc_html__( 'Weeks', 'slidingmarketing' ) );
								$on_hide = slidingmarketing_get_option ( 'on_hide' );
								$enabled = ! empty ( $on_hide );
								$reshow_after_time = $enabled ? slidingmarketing_get_option ( 'reshow_after_setup' ) : false;
								$reshow_after_units = $enabled ? slidingmarketing_get_option ( 'reshow_after_setup_timer' ) : false;
								
								$time_box = "<select name='sm[reshow_after_setup]'><option value=''></option>";
								foreach ( $_times as $_time ) {
									$selected = $_time == $reshow_after_time ? 'selected="selected"' : '';
									$time_box .= "<option value='{$_time}' {$selected}>{$_time}</option>";
								}
								$time_box .= "</select>";
								
								$unit_box = "<select name='sm[reshow_after_setup_timer]'><option value=''></option>";
								foreach ( $_units as $key => $_unit ) {
									$selected = $key == $reshow_after_units ? 'selected="selected"' : '';
									$unit_box .= "<option value='{$key}' {$selected}>{$_unit}</option>";
								}
								$unit_box .= "</select>";
								
								echo '<div class="sm-reshow_after" >' . '<label for=""><b>' . esc_html__( 'Show the messages again after:', 'slidingmarketing' ) . '</b></label><br />' . "{$time_box} {$unit_box}" . '</div>';
								
								?>
						  </td>
						</tr>
					</table>
				</div>

				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">Custom Styles</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%" class="smui-table">

						<col width="20%" />
						<col width="80%" />

						<tr class="odd">
							<td class="param">Custom CSS:</td>
							<td>
							
							<?php
							
							$css = esc_textarea ( wp_strip_all_tags ( slidingmarketing_get_option ( 'css-custom-user-styles' ) ) );
							$placeholder = esc_attr ( esc_html__( 'Additional CSS styles', 'slidingmarketing' ) );
							
							echo "<textarea class='widefat' rows='8' name='sm[css-custom-user-styles]' placeholder='{$placeholder}'>{$css}</textarea>";
							
							?>
							
							</td>
						</tr>
					</table>
				</div>

				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">Advanced Options</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%" class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">Allow multiple displayed messages in automatically display mode:<br/><span class="sm-info-label">Enabling this option will allow you to display more then one message in automatically display mode.</span></td>
							<td>
							
							<?php 
							echo '' .
									'<input type="hidden" name="sm[allow_multiple]" value="" />' .
									'<input type="checkbox" name="sm[allow_multiple]" id="sm-allow_widgets" value="1" ' . (slidingmarketing_get_option('allow_multiple') ? 'checked="checked"' : '') . ' />' .									
									'';
							?>
							
							</td>
						</tr>
						<?php 
						$value = (slidingmarketing_get_option('allow_multiple_count') ? slidingmarketing_get_option('allow_multiple_count') : '1');
						$widget_select = '<div class="smui-ui-select1"><select name="sm[allow_multiple_count]">';
						for($i = 1; $i < 11; $i ++) {
							$selected = ($i == $value) ? 'selected="selected"' : '';
							$widget_select .= "<option value='{$i}' {$selected}>{$i}&nbsp;</option>";
						}
						$widget_select .= '</select></div>';
						
						?>
						<tr class="odd">
							<td class="param">Number of displayed messages:<br/><span class="sm-info-label">If you enable multiple displayed messages in automatically display mode here you can select the maximum number of display messages according to display condition rules.</span></td>
							<td>
							
							<?php 
							echo $widget_select;
							?>
							
							</td>
						</tr>
						
						<tr class="odd">
							<td class="param">Allow widgets:<br/><span class="sm-info-label">Enabling this option will add a new sidebar that you can populate with widgets in Appearance > Widgets.</span></td>
							<td>
							
							<?php 
							echo '' .
									'<input type="hidden" name="sm[allow_widgets]" value="" />' .
									'<input type="checkbox" name="sm[allow_widgets]" id="sm-allow_widgets" value="1" ' . (slidingmarketing_get_option('allow_widgets') ? 'checked="checked"' : '') . ' />' .									
									'';
							?>
							
							</td>
						</tr>
						<?php 
						$value = (slidingmarketing_get_option('allow_widgets_count') ? slidingmarketing_get_option('allow_widgets_count') : '1');
						$widget_select = '<div class="smui-ui-select1"><select name="sm[allow_widgets_count]">';
						for($i = 1; $i < 11; $i ++) {
							$selected = ($i == $value) ? 'selected="selected"' : '';
							$widget_select .= "<option value='{$i}' {$selected}>{$i}&nbsp;</option>";
						}
						$widget_select .= '</select></div>';
						
						?>
						<tr class="even">
							<td class="param">Number of widget areas:<br/><span class="sm-info-label">If you enable allow widgets option here you can select number of widgets that plugin can use.</span></td>
							<td>
							
							<?php 
							echo $widget_select;
							?>
							
							</td>
						</tr>
						
						<tr class="odd">
							<td class="param">Hide on mobile:<br/><span class="sm-info-label">Activate message not display for mobile devices (tablets are excluded from these options).</span></td>
							<td>
							
							<?php 
							
							$hide_condition_mobile = slidingmarketing_get_option('hide_condition_mobile');
							$hide_condition_mobile_resolution = slidingmarketing_get_option('hide_condition_mobile_resolution');
							$checked = ($hide_condition_mobile == 'true') ? 'checked="checked"' : '';
							
							echo '<br/>' .
									'<input type="checkbox" name="sm[hide_condition_mobile]" value="true" id="sm-hide_condition_mobile" ' . $checked . ' autocomplete="off" />' .
									'&nbsp;' .
									'<label for="sm-hide_condition_mobile">' . esc_html__('Hide on mobile devices with resolution lower than', 'slidingmarketing') . '</label>' .
									'&nbsp;' .
									'<input type="text" size="8" class="medium" name="sm[hide_condition_mobile_resolution]" id="sm-hide_condition_mobile_resolution" value="' . (int)$hide_condition_mobile_resolution . '"  />px' .
									'';
							
							?>
							
							</td>
						</tr>
						<tr class="even">
							<td class="param">Do not load FontAwesome:<br/><span class="sm-info-label">Enabling this option will remove loading of FontAwesome by plugin. Do this if you do not plan to use FontAwesome or you already have it loaded from another plugin or theme.</span></td>
							<td>
							
							<?php 
							echo '' .
									'<input type="hidden" name="sm[deactivate_fa]" value="" />' .
									'<input type="checkbox" name="sm[deactivate_fa]" id="sm-deactivate_fa" value="1" ' . (slidingmarketing_get_option('deactivate_fa') ? 'checked="checked"' : '') . ' />' .									
									'';
							?>
							
							</td>
						</tr>
					</table>
				</div>
				
				<!-- subscribe connectors -->
				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">Subscribe Services Connection</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%"
						class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">Subscribe to Email service:<br/><span class="sm-info-label">If you wish to use build in subscribe component you need to choose a service from the list and fill required connection details.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_connector');
								echo '<select name="sm[subscribe_connector]">';
								echo '<option value="mailchimp" '.($connector == 'mailchimp' ? 'selected' : '').'>MailChimp</option>';
								echo '<option value="mymail" '.($connector == 'mymail' ? 'selected' : '').'>myMail</option>';
								echo '<option value="mailpoet" '.($connector == 'mailpoet' ? 'selected' : '').'>MailPoet</option>';
								echo '<option value="mailerlite" '.($connector == 'mailerlite' ? 'selected' : '').'>MailerLite</option>';
								echo '<option value="activecampaign" '.($connector == 'activecampaign' ? 'selected' : '').'>ActiveCampaign</option>';
								echo '<option value="campaignmonitor" '.($connector == 'campaignmonitor' ? 'selected' : '').'>CampaignMonitor</option>';
								echo '<option value="sendinblue" '.($connector == 'sendinblue' ? 'selected' : '').'>SendinBlue</option>';
								echo '</select>';
								
								?>
							</td>
						</tr>
					</table>
				</div>
				
				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">MailChimp</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%"
						class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">Mailchimp API key:<br/><span class="sm-info-label"><a href="http://kb.mailchimp.com/accounts/management/about-api-keys#Finding-or-generating-your-API-key" target="_blank">Find your API key</a>.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_mc_api');
								echo '<input class="widefat" type="text" name="sm[subscribe_mc_api]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
						<tr class="odd">
							<td class="param">Mailchimp List ID:<br/><span class="sm-info-label"><a href="http://kb.mailchimp.com/lists/managing-subscribers/find-your-list-id" target="_blank">Find my List ID</a>.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_mc_list');
								echo '<input class="widefat" type="text" name="sm[subscribe_mc_list]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
					</table>
				</div>
				

				
				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">MyMail/Mailster</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%"
						class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">List:<br/><span class="sm-info-label"></span></td>
							<td>
								<?php 
								$listOfOptions = array();
								if (function_exists('mymail')) {
									$lists = mymail('lists')->get();
									foreach ($lists as $list) {
										if (function_exists('mymail')) $id = $list->ID;
										else $id = $list->term_id;
								
										$listOfOptions[$id] = $list->name;
									}
								}
								$connector = slidingmarketing_get_option('subscribe_mm_list');
								
								echo '<select name="sm[subscribe_mm_list]">';
								foreach ($listOfOptions as $id => $text) {
									echo '<option value="'.$id.'" '.(($id == $connector) ? 'selected' : '').'>'.$text.'</option>';
								}
								echo '</select>';
								
								?>
							</td>
						</tr>
						
					</table>
				</div>

				
				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">MailPoet</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%"
						class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">List:<br/><span class="sm-info-label"></span></td>
							<td>
							<?php 
								$listOfOptions = array();
try {
	if (class_exists('WYSIJA')) {
		$model_list = WYSIJA::get('list', 'model');
		$mailpoet_lists = $model_list->get(array('name', 'list_id'), array('is_enabled'=>1));
		if (sizeof($mailpoet_lists) > 0) {
			foreach ($mailpoet_lists as $list) {
				$listOfOptions[$list['list_id']] = $list['name'];
			}
		}
	}
	if (class_exists('\MailPoet\API\API')) {
		$subscription_lists = \MailPoet\API\API::MP('v1')->getLists();
		if (is_array($subscription_lists)) {
			foreach ($subscription_lists as $list) {
				$listOfOptions[$list['id']] = $list['name'];
			}
		}
	}
}
catch (Exception $e) {
	
}
								$connector = slidingmarketing_get_option('subscribe_mp_list');
								
								echo '<select name="sm[subscribe_mp_list]">';
								foreach ($listOfOptions as $id => $text) {
									echo '<option value="'.$id.'" '.(($id == $connector) ? 'selected' : '').'>'.$text.'</option>';
								}
								echo '</select>';
								
								?>
							</td>
						</tr>

					</table>
				</div>

				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">MailerLite</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%"
						class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">MailerLite API key:<br/><span class="sm-info-label"><a href="https://app.mailerlite.com/subscribe/api" target="_blank">Find your API key</a>.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_ml_api');
								echo '<input class="widefat" type="text" name="sm[subscribe_ml_api]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
						<tr class="odd">
							<td class="param">MailerLite List ID (Group ID):<br/><span class="sm-info-label">Enter your list id (aka Group ID). To find your group id visit again the page for API key generation and you will see all list you have with their ids</td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_ml_list');
								echo '<input class="widefat" type="text" name="sm[subscribe_ml_list]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
					</table>
				</div>

				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">ActiveCampaign</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%"
						class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">ActiveCampaign API URL:<br/><span class="sm-info-label">Enter your ActiveCampaign API URL. To get API URL please go to your ActiveCampaign Account >> My Settings >> Developer.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_ac_api_url');
								echo '<input class="widefat" type="text" name="sm[subscribe_ac_api_url]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
						<tr class="odd">
							<td class="param">ActiveCampaign API Key:<br/><span class="sm-info-label">Enter your ActiveCampaign API Key. To get API Key please go to your ActiveCampaign Account >> My Settings >> Developer.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_ac_api');
								echo '<input class="widefat" type="text" name="sm[subscribe_ac_api]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
						<tr class="even">
							<td class="param">ActiveCapaign List ID:<br/><span class="sm-info-label">Entery your ActiveCampaign List ID. To get your list ID visit lists pages and copy ID that you see in browser when you open list ?listid=.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_ac_list');
								echo '<input class="widefat" type="text" name="sm[subscribe_ac_list]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
					</table>
				</div>

				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">CampaignMonitor</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%"
						class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">CampaignMonitor API Key:<br/><span class="sm-info-label">Enter your Campaign Monitor API Key. You can get your API Key from the Account Settings page when logged into your Campaign Monitor account.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_cm_api');
								echo '<input class="widefat" type="text" name="sm[subscribe_cm_api]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
						<tr class="odd">
							<td class="param">CampaignMonitor List ID:<br/><span class="sm-info-label">Enter your List ID. You can get List ID from the list editor page when logged into your Campaign Monitor account.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_cm_list');
								echo '<input class="widefat" type="text" name="sm[subscribe_cm_list]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
					</table>
				</div>

				<div class="sm-dashboard-panel">
					<div class="sm-dashboard-panel-title">SendinBlue</div>

					<table border="0" cellpadding="2" cellspacing="0" width="100%"
						class="smui-table">

						<col width="20%" />
						<col width="80%" />
						
						<tr class="even">
							<td class="param">SendinBlue API Key:<br/><span class="sm-info-label">Enter your SendinBlue API Key. You can get your API Key from here (API key version 2.0).</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_sib_api');
								echo '<input class="widefat" type="text" name="sm[subscribe_sib_api]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
						<tr class="odd">
							<td class="param">SendinBlue List ID:<br/><span class="sm-info-label">Enter your list ID.</span></td>
							<td>
								<?php 
								
								$connector = slidingmarketing_get_option('subscribe_sib_list');
								echo '<input class="widefat" type="text" name="sm[subscribe_sib_list]" value="'.$connector.'"/>';
								
								?>
							</td>
						</tr>
					</table>
				</div>
				
				<!-- end: subscribe connectors -->
			</div>
		</div>

	</form>
</div>

</div>