<?php

add_shortcode('sm_close', 'slidingmessages_message_close_link');
add_shortcode('sm-close', 'slidingmessages_message_close_link');
add_shortcode('sm-countdown', 'slidingmessages_message_countdown');
add_shortcode('sm-button', 'slidingmessages_button_sc');
add_shortcode('sm-col', 'slidingmessages_columns_sc');
add_shortcode('sm-one-half', 'slidingmessages_columns_sc');
add_shortcode('sm-one-third', 'slidingmessages_columns_sc');
add_shortcode('sm-one-quarter', 'slidingmessages_columns_sc');
add_shortcode('sm-two-thirds', 'slidingmessages_columns_sc');
add_shortcode('sm-highlight', 'slidingmessages_highlight_sc');
add_shortcode('sm-subscribe', 'slidingmessages_subscribe_sc');
add_shortcode('sm-post', 'slidingmessages_post_sc');

function slidingmessages_generate_message($message) {
	include SLIDINGMESSAGES_PLUGIN_BASE_DIR . '/includes/template/template-message.php';
}

function slidingmessages_generate_additional_button_classes($message) {
	$classes = array();
	
	$classes[] = 'sm-position-'.get_post_meta($message->ID, 'sm-position', true);
	
	if (slidingmarketing_message_setting($message, 'open-show')) {
		$classes[] = 'slidingmessage-active';
	}
	
	
	echo implode(' ', $classes);
}

function slidingmessages_generate_additional_message_classes($message) {
	$classes = array();
	
	$message_position = get_post_meta($message->ID, 'sm-position', true);
	
	if (isset($_REQUEST['smpos'])) {
		$message_position = $_REQUEST['smpos'];
	}
	
	$classes[] = 'sm-position-'.esc_attr($message_position);
	$classes[] = 'sm-shadow-'.get_post_meta($message->ID, 'sm-shadow', true);
	
	$effect = get_post_meta($message->ID, 'sm-effect', true);
	
	if (isset($_REQUEST['smeffect'])) {
		$effect = $_REQUEST['smeffect'];
	}
	
	if ($effect != '') {
		$classes[] = $effect;
	}
	
	if (get_post_meta($message->ID, 'sm-reopen-show', true)) {
		$classes[] = 'sm-reopen';
	}
	
	if (get_post_meta($message->ID, 'sm-center-vertical', true)) {
		$classes[] = 'sm-vertical-middle';
		
	}
	
	echo implode(' ', $classes);
}

function slidingmessages_message_additional_data_params($message) {
	$params = array();
	
	$params[] = 'data-appear="'.esc_attr(get_post_meta($message->ID, 'sm-show-at', true)).'"';
	$params[] = 'data-appear-at="'.esc_attr(get_post_meta($message->ID, 'sm-show-at-condition', true)).'"';
	$params[] = 'data-disappear="'.esc_attr(get_post_meta($message->ID, 'sm-disappear-after', true)).'"';
	$params[] = 'data-reopen="'.esc_attr(get_post_meta($message->ID, 'sm-reopen-show', true)).'"';
	$params[] = 'data-forcehide="'.esc_attr(get_post_meta($message->ID, 'sm-disappear-hide', true)).'"';
	$params[] = 'data-forcehide-days="'.esc_attr(get_post_meta($message->ID, 'sm-disappear-hide-days', true)).'"';
	$params[] = 'data-id="'.esc_attr($message->ID).'"';
	$params[] = 'data-nocookie="'.esc_attr(get_post_meta($message->ID, 'sm-nocookies', true)).'"';
	
	
	echo implode(' ', $params);
}

function slidingmessages_message_additional_data_params_open_button($message) {
	
	$params = array();
	
	$params[] = 'data-reopen="'.esc_attr(get_post_meta($message->ID, 'sm-reopen-show', true)).'"';
	$params[] = 'data-id="'.esc_attr($message->ID).'"';
	
	
	echo implode(' ', $params);
	
}

function slidingmessages_message_countdown($atts = array()) {
	$date = isset($atts['date']) ? $atts['date'] : '';
	$mode = isset($atts['mode']) ? $atts['mode'] : 'dark';
	$shadow = isset($atts['shadow']) ? $atts['shadow'] : '';
	$mini = isset($atts['mini']) ? $atts['mini'] : '';
		
	$code = '<div class="sm-countdown '.esc_attr($mode).' '.($shadow == 'yes' ? 'shadow': '').' '.($mini == "yes" ? 'mini' : '').'" data-timer="'.$date.'"><div class="counter">';
	$code .= '<div class="days">
      <div class="value">00</div>
      <span>Days</span>
    </div>

    <div class="hours">
      <div class="value">00</div>
      <span>Hours</span>
    </div>

    <div class="minutes">
      <div class="value">00</div>
      <span>Minutes</span>
    </div>

    <div class="seconds">
      <div class="value">00</div>
      <span>Seconds</span>
    </div>';
	$code .= '</div></div>';
	
	return $code;
}

function slidingmessages_message_close_link($atts = array()) {
	$text = isset($atts['text']) ? $atts['text'] : '';
	$classes = isset($atts['class']) ? $atts['class'] : '';
	$button = isset($atts['button']) ? $atts['button'] : '';
	
	if ($button != '') {
		if ($classes != '') {
			$classes .= ' sm-manual-close-button-'.esc_attr($button);
		}
		else {
			$classes = 'sm-manual-close-button-'.esc_attr($button);
		}
	}
	
	return '<a href="#" class="sm-manual-close '.$classes.'">'.$text.'</a>';
}

function slidingmessages_message_custom_styles($message) {
	// message settings
	$width = slidingmarketing_message_setting($message, 'width');
	$height = slidingmarketing_message_setting($message, 'height');
	$background = slidingmarketing_message_setting($message, 'background');
	$remove_background = slidingmarketing_message_setting($message, 'remove-background');
	$textcolor = slidingmarketing_message_setting($message, 'textcolor');
	$highlight = slidingmarketing_message_setting($message, 'highlight');
	$padding = slidingmarketing_message_setting($message, 'padding');
	$background_image = slidingmarketing_message_setting($message, 'background-image');
	
	$shadow_style = slidingmarketing_message_setting($message, 'shadow');
	
	$subscribe_button_text = slidingmarketing_message_setting($message, 'subscribe-button-textcolor');
	$subscribe_button_bg = slidingmarketing_message_setting($message, 'subscribe-button-bgcolor');
	
	$r = '';
	
	if ($subscribe_button_text != '') {
		$r .= '#slidingmessage-'.$message->ID.' .sm-subscribe-submit { color: '.esc_attr($subscribe_button_text).'!important;}';
	}
	if ($subscribe_button_bg != '') {
		$r .= '#slidingmessage-'.$message->ID.' .sm-subscribe-submit { background-color: '.esc_attr($subscribe_button_bg).'!important;}';
	}
	
	if ($width != '') {
		$r .= '#slidingmessage-'.$message->ID.' { width: '.esc_attr($width).'px;}';
	}
	
	if ($height != '') {
		$r .= '#slidingmessage-'.$message->ID.' { height: '.esc_attr($height).'px;}';
	}
	
	if ($background != '') {
		$r .= '#slidingmessage-'.$message->ID.' { background: '.esc_attr($background).';}';
	}
	
	if ($remove_background) {
		$r .= '#slidingmessage-'.$message->ID.' { background: transparent; }';
	}
	
	if ($textcolor != '') {
		$r .= '#slidingmessage-'.$message->ID.' { color: '.esc_attr($textcolor).'; }';
	}
	
	if ($highlight != '') {
		$r .= '#slidingmessage-'.$message->ID.' a { color: '.esc_attr($highlight).'; }';
	}
	
	if ($shadow_style == 'border') {
		$shadow_border_color = $highlight != '' ? $highlight : 'rgba(0,0,0,0.1)';
		$r .= '#slidingmessage-'.$message->ID.' { border: 1px solid '.esc_attr($shadow_border_color).'}';
	}
	
	if ($padding != '') {
		$r .= '#slidingmessage-'.$message->ID.' .sm-content { padding: '.esc_attr($padding).'; }';
	}
	
	if ($background_image) {
		$r .= '#slidingmessage-'.$message->ID.' { background: url('.esc_url(wp_get_attachment_url($background_image)).'); background-size: cover; background-position: center; }';
	}
	
	$close_color = slidingmarketing_message_setting($message, 'close-color');
	$close_background = slidingmarketing_message_setting($message, 'close-background');
	
	if ($close_color != '') {
		$r .= '#slidingmessage-'.$message->ID.' .sm-close a { color: '.esc_attr($close_color).'; }';
	}
	if ($close_background != '') {
		$r .= '#slidingmessage-'.$message->ID.' .sm-close a { background-color: '.esc_attr($close_background).'; }';
	}
	
	$open_background = slidingmarketing_message_setting($message, 'open-background');
	$open_color = slidingmarketing_message_setting($message, 'open-textcolor');
	
	if ($open_color != '') {
		$r .= '#slidingmessage-open-'.$message->ID.' { color: '.esc_attr($open_color).'; }';
	}
	if ($open_background != '') {
		$r .= '#slidingmessage-open-'.$message->ID.' { background-color: '.esc_attr($open_background).'; }';
	}
	
	return $r;
}

function slidingmessages_get_related_posts($post_id, $taxonomy, $limit = 3) {
	$post_id = ( int ) $post_id;

	if ($taxonomy == 'smnextpost') {
		$next_post = get_next_post ();
		$query = new stdClass ();
		$query->posts = array ();
		$query->posts [] = $next_post;
	} else {
		$raw_tags = wp_get_object_terms ( $post_id, $taxonomy, array ('fields' => 'ids' ) );
			
		$query = new WP_Query ( array ('post__not_in' => array ($post_id ), 'tax_query' => array (array ('taxonomy' => $taxonomy, 'terms' => $raw_tags, 'field' => 'id' ) ), 'posts_per_page' => $limit ) );
	}

	return $query->posts;

}

function slidingmessages_button_sc( $atts, $content = false, $tag ) {
	extract( shortcode_atts(  array( 'size' => 'large', 'style' => 'rounded', 'title' => '', 'url' => '#', 'target' => '_self', 'icon' => '', 'bg_color' => '#000000', 'txt_color' => '#ffffff', 'icon_type' => 'fa', 'nofollow' => 0, 'close' => '' ), $atts ) );
	$inl_style = 'style="color: '.esc_attr($txt_color).'; background-color: '.esc_attr($bg_color).'"';
	$icon_type = ( $icon_type == 'fa' ) ? 'fa ' : '';
	$icon = $icon ? '<i class="'.esc_attr($icon_type.$icon).'"></i>' : '';
	$nofollow = $nofollow ? 'rel="nofollow"' : '';
	
	$close_action = ($close == "yes") ? "sm-manual-close" : '';
	
	$output = '<a class="sm_button sm_button_'.esc_attr($size).' '.esc_attr($style).' '.esc_attr($close_action).'" href="'.esc_url($url).'" target="'.esc_attr($target).'" '.$inl_style.' '.$nofollow.'>' . $icon . $title . '</a>';
	return $output;
}

function slidingmessages_columns_sc( $atts, $content = false, $tag ) {
	extract( shortcode_atts(  array( 'class' => '' ), $atts ) );
	$output = '<div class="'.esc_attr($tag).'">' . do_shortcode( $content ) . '</div>';
	return $output;
}

function slidingmessages_highlight_sc($atts = array(), $content = '') {
	extract( shortcode_atts(  array( 'bg_color' => '', 'text_color' => '' ), $atts ) );
	
	return '<span class="sm_highlight" style="'.($bg_color != '' ? 'background-color:'.esc_attr($bg_color).';' : '').($text_color != '' ? 'color:'.esc_attr($text_color).';' : '').'">'.$content.'</span>';
}

function slidingmessages_subscribe_sc($atts = array()) {
	extract( shortcode_atts(  array( 'form_mode' => '' ), $atts ) );
	
	if ($form_mode == '') {
		$form_mode = 'default';
	}
	
	ob_start();
	echo '<div class="sm-subscribe-inline form-mode-'.esc_attr($form_mode).'">';
	include SLIDINGMESSAGES_PLUGIN_BASE_DIR . '/includes/template/template-subscribe.php';
	echo '</div>';
	
	$user_code = ob_get_contents();
	ob_end_clean();
	
	return $user_code;
}

function slidingmessages_post_sc($atts = array()) {
	extract( shortcode_atts(  array( 'post_id' => '', 'next_post' => '', 'prev_post' => '', 'thumb_size' => '', 'design' => '' ), $atts ) );
	
	$output = '';
	
	if ($design == 'mini' && $thumb_size == '') {
		$thumb_size = 'thumbnail';
	}
	
	if ($thumb_size == '') {
		$thumb_size = 'full';
	}	
	
	if ($post_id != '') {
		$post = get_post($post_id);
	}
	
	if ($prev_post == 'yes') {
		$post = get_adjacent_post( true, '', true, 'category');
	}
	
	if ($next_post == 'yes') {
		$post = get_adjacent_post( true, '', false, 'category');
	}
	
	if (isset($post)) {
		$output .= '<div class="sm-postcard '.($design != '' ? 'sm-card-'.esc_attr($design) : '').'">';
		
		$featured_image = get_the_post_thumbnail_url($post->ID, $thumb_size);
		if ($featured_image != '') {
			$output .= '<div class="sm-postcard-image">';
			$output .= '<a href="'.esc_url(get_permalink($post->ID)).'"><img src="'.esc_url($featured_image).'"/></a>';
			$output .= '</div>';
		}
		
		$output .= '<div class="sm-postcard-content">';
		$output .= '<a href="'.esc_url(get_permalink($post->ID)).'"><h3>'.esc_url(get_the_title($post->ID)).'</h3></a>';
		
		$output .= '<div class="sm-postcard-cat">';
		$category = get_the_category($post->ID);
		$output .= $category[0]->cat_name;
		$output .= '</div>';
		
		$output .= '<div class="sm-postcard-desc">';
		$working_post_content = $post->post_content;
		
		$post_shortdesc = $post->post_excerpt;
		if ($post_shortdesc != '') {
			$working_post_content = $post_shortdesc;
		}
		
		$working_post_content = strip_tags ( $working_post_content );
		$working_post_content = preg_replace( '/\s+/', ' ', $working_post_content );
		$working_post_content = strip_shortcodes($working_post_content);
		$working_post_content = trim ( $working_post_content );
		$working_post_content = substr ( $working_post_content, 0, 150 );
		$working_post_content .= '&hellip;';
				
		$output .= $working_post_content;
		
		$output .= '</div>';
		$output .= '</div>';
		
		$output .= '</div>';
	}
	
	return $output;
}