<?php
?>

<div id="slidingmessage-<?php echo esc_attr($message->ID);?>" class="slidingmessage <?php slidingmessages_generate_additional_message_classes($message); ?>" <?php slidingmessages_message_additional_data_params($message); ?>>
	<?php if (!slidingmarketing_message_setting($message, 'close-hide')): ?>
		<div class="sm-close sm-close-size-<?php slidingmarketing_message_setting_draw($message, 'close-size');?> sm-close-shape-<?php slidingmarketing_message_setting_draw($message, 'close-shape');?> sm-close-place-<?php slidingmarketing_message_setting_draw($message, 'close-placement');?>">
			<a href="#" data-close="slidingmessage-<?php echo esc_attr($message->ID);?>"></a>
		</div>
	<?php endif; ?>

	<div class="sm-content <?php slidingmarketing_message_setting_draw($message, 'message-type'); ?>">
	
		<?php 
		
		$message_content_parts = slidingmarketing_message_settings($message, 'message-type');		
		
		if (in_array('text', $message_content_parts)) {
			echo do_shortcode($message->post_content);
		}
		
		if (in_array('sidebar', $message_content_parts)) {
			$sidebar_id = slidingmarketing_message_setting($message, 'sidebar-id');
			
			
			if (is_active_sidebar ( 'slidingmarketing-' . $sidebar_id )) {
				echo '<div class="sm-sidebar-area">';
				dynamic_sidebar ( 'slidingmarketing-' . $sidebar_id );
				echo '</div>';
			} else {
				$content = esc_html__( 'Please, add some widgets to your sidebar.', 'slidingmarketing' );
				if ($content) {
					echo $content;
				}
			}
		}
		
		if (in_array('related', $message_content_parts)) {
			$post_id = is_singular () ? get_the_ID () : false;
			$related_taxonomy = slidingmarketing_message_setting($message, 'relation-type');
			if ($related_taxonomy == '') {
				$related_taxonomy = 'category';
			}
			
			$related_posts_count = slidingmarketing_message_setting($message, 'related-count');
			$related_design = slidingmarketing_message_setting($message, 'related-design');
			
			$posts = slidingmessages_get_related_posts ( $post_id, $related_taxonomy, $related_posts_count );
			$current_post_id = $post_id;
				
			echo '<div class="sm-related-posts">';
			
			foreach ($posts as $post) {
				if ($related_design == 'minimal') {
					echo '<div class="sm-related-post">';
					echo '<h4 class="entry-title"><a href="'.esc_url(get_the_permalink($post->ID)).'">'.get_the_title($post->ID).'</a></h4>';
					echo '<div class="entry-meta">';
					echo '<time class="published" datetime="'.esc_attr(get_the_time('c')).'">'.get_the_time('F j, Y g:i a').'</time>';
					echo '</div>';
					echo '</div>';
				}

				if ($related_design == 'classic' || $related_design == 'jumbo') {
					echo '<div class="sm-related-post sm-design-'.$related_design.'">';
					
					$image = get_post_thumbnail_id($post->ID, ($related_design == 'classic' ? 'thumbnail' : 'medium'));
					
					?>
					<div class="entry-image">
						<a href="<?php echo esc_url(get_the_permalink($post->ID)); ?>" rel="bookmark">
					       <img src="<?php echo esc_url(wp_get_attachment_url( $image )); ?>"/>
						</a>
					</div>
					<?php 
					echo '<div class="post-content-related">';
					echo '<h4 class="entry-title"><a href="'.esc_url(get_the_permalink($post->ID)).'">'.get_the_title($post->ID).'</a></h4>';
					echo '<div class="entry-meta">';
					echo '<time class="published" datetime="'.esc_attr(get_the_time('c')).'">'.get_the_time('F j, Y g:i a').'</time>';
					echo '</div>';
					echo '</div>';
					echo '</div>';
					echo '<div class="sm-clear"></div>';
				}
			}
			
			echo '</div>';
		}
		
		if (in_array('optin', $message_content_parts)) {
			include SLIDINGMESSAGES_PLUGIN_BASE_DIR . '/includes/template/template-subscribe.php';
		}
		
		?>
	
	</div>
</div>

<?php if (slidingmarketing_message_setting($message, 'reopen-show') || slidingmarketing_message_setting($message, 'open-show')): ?>

<div id="slidingmessage-open-<?php echo esc_attr($message->ID);?>" class="slidingmessage-open <?php slidingmessages_generate_additional_button_classes($message); ?>" <?php slidingmessages_message_additional_data_params_open_button($message); ?>>

	<?php 
	$user_icon = slidingmarketing_message_setting($message, 'fa-icon');
	$user_icon_size = slidingmarketing_message_setting($message, 'fa-size');
	
	if ($user_icon != '') {
		echo '<i class="fa '.esc_attr($user_icon).' '.($user_icon_size != '' ? esc_attr($user_icon_size) : '').'"></i>';
	}
	
	?>

	<?php echo do_shortcode(slidingmarketing_message_setting($message, 'open-content')); ?>
</div>
<?php endif; ?>